'' Long name

' To compile (1.2.9)
'
' zxb -t -B -a -S 29000 -H 256 maritrini.bas

#include once "mapa.bas"
#include once "printer.bas"
#include once "inventory.bas"
#include once "tileset.bas"
#include once "subacolib.bas"
#include once "behaviours.bas"
#include once "sound.bas"
#include once "engine.bas"
#include once "mapdraw.bas"
#include once "beepmusic.bas"

Dim flag1 as uByte
Dim flag2 as uByte
Dim looper as uByte
Dim state as uByte

initRestorableTiles ()
Border 0: Paper 0: Ink 7: Cls

Do
	title ()
	
	'' Game
	drawFrame()
	
	'' New game
	splashScreen ()
	initObjContainers ()
	initGame ()
	initBombs ()
	inventoryInit ()
''inventory(0)=4:inventory(1)=5:inventory(2)=6:inventory(3)=7	
	subacoDefSprite (0, 16)
	subacoActivateSprite (0)
	mapDraw (nPant)
	drawInventory ()
	showLife ()
	showBombs ()
	
	' No enemies on first screen!
	bombScare = 1
	
	flag1 = 0
	flag2 = 0
	While Not flag1
		'' Move stuff
		movePlayer ()
		moveEnemies ()
		
		'' Update sprites
		subacoMoveSprite (0, 1 + plX, 1 + plY)
		subacoDefSprite (0, 16 + plFacing + plFacing + plFrame)
		For looper = 0 To 1
			state = enState (looper)
			If state = STATESPAWNING Then
				subacoMoveSprite (1 + looper, 1 + enX (looper), 1 + enY (looper))
				If enCt (looper) & 1 = 1 Then
					subacoDefSprite (1 + looper, 24 + enType (looper) + enType (looper))
				Else
					subacoDefSprite (1 + looper, 0)
				End If
			ElseIf state = STATESTILL or state = STATEWALKING Then
				subacoMoveSprite (1 + looper, 1 + enX (looper), 1 + enY (looper))
				subacoDefSprite (1 + looper, 24 + enType (looper) + enType (looper) + enFrame (looper))
				'' COLLIDE
				If collision (looper) Then
					flag1 = oneLifeLess ()
					showLife ()
					enState (looper) = STATEDYING
					enWasKilled (looper) = 1
					makeSound (SOUNDCOLLISION)
				End If
			ElseIf state = STATEDYING Then
				subacoDefSprite (1 + looper, 11 + (enCt (looper) & 1))
			End If
		Next looper
		
		'' blit blot
		subacoMoveSpritesLowBorder ()
	
		'' Draw bomb if exists. Check if player dies as well.	
		flag1 = flag1 Or moveBomb ()
		
		'' ending
		If nPant = 43 Then
			If plX = 9 And plY =9  Then
				If inventoryExists (4) And inventoryExists (5) And inventoryExists (6) And inventoryExists (7) Then
					flag1 = 1: flag2 = 1
				Else
					makeSound (SOUNDWRONG)
					' Generate walk DOWN
					plState = STATEWALKING
					plMY = 1
					plNYr = plYr + 1
					plCt = 0
				End If
			End If
		End If
	Wend
	
	If flag2 = 0 Then 
		' Here game over
		gameOver ()
	Else
		' Here ending
		ending ()
	End If
	flag2 = 0
Loop